from system.ev3_queue import ev3_queue as Queue
import threading
import sys
from system.communication_thread import communication_thread
from system.program_thread import program_thread
from Tkinter import *
import time
#for the command window start
root=Tk()
#root.minsize(900,500)
root.title("robot commands")
root.config(bg='white')
#will raise exceptions
def shutdown_function():
    root.destroy()
    sys.exit()
connected=threading.Event()
start_program_event=threading.Event()
connected_command=threading.Event()
reconnect=threading.Event()
ip_adress_queue=Queue()
def connect_function():
        ip_adress=ip_entry.get()
        config_file=open("config.txt", "w")
        config_file.truncate()
        config_file.write(ip_adress)
        config_file.close()
        if not ip_adress_queue.empty():
            while not ip_adress_queue.empty():
                temp=ip_adress_queue.get()
        ip_adress_queue.put(ip_adress)
        connected_command.set()
        
def shutdown_robot():
    print("shutdown have been pressed")
    queue_command.put(["shutdown"])
    time.sleep(3)
    shutdown_function()
def start_program():
    start_program_event.set()
connect_button=Button(root, text="connect", width=15, command=connect_function)
ip_entry = Entry(root)
shutdown_button=Button(root, text="shutdown program", width=15, command=shutdown_function)
shutdown_robot_button=Button(root, text="shutdown robot", width=15, command=shutdown_robot)
start_program_button=Button(root, text="start program", width=15, command=start_program)
connect_button.pack()
ip_entry.pack()
ip_entry.delete(0, END)
try:
    config_file = open("config.txt", "r")
    ip_adress=config_file.read()
    config_file.close()
except IOError,e:
    ip_adress="0.0.0.0"
    config_file = open("config.txt", "w")
    config_file.write(ip_adress)
    config_file.close()
ip_entry.insert(0, ip_adress)
start_program_button.pack()
shutdown_button.pack()
shutdown_robot_button.pack()
root.update()
window_width=root.winfo_width()
window_height=root.winfo_height()
#for the command window end
queue_command=Queue()
queue_data=Queue()
kill=threading.Event()
connected=threading.Event()
reconnect=threading.Event()
a=communication_thread(queue_command,queue_data,kill,connected,reconnect,connected_command,ip_adress_queue)
a.daemon=True
a.start()
b=program_thread(queue_command,queue_data,kill,start_program_event,ip_adress_queue)
b.daemon=True
b.start()
while True:
    if kill.is_set():
        sys.exit()
    if connected.is_set():
        connect_button.configure(bg="green")
    root.update()